using System.Collections.Generic;
using System.Threading.Tasks;

namespace SZUAbsolventenverein.Module.EventRegistration.Repository
{
    public interface IEventRegistrationRepository
    {
        IEnumerable<Models.Event> GetEventRegistrations(int ModuleId);
        Models.Event GetEventRegistration(int EventRegistrationId);
        Models.Event GetEventRegistration(int EventRegistrationId, bool tracking);
        Models.Event AddEventRegistration(Models.Event EventRegistration);
        Models.Event UpdateEventRegistration(Models.Event EventRegistration);
        void DeleteEventRegistration(int EventRegistrationId);
    }
}
