using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace SZUAbsolventenverein.Module.EventRegistration.Services
{
    public interface IEventRegistrationService 
    {
        /* Reine Events */
        Task<List<Models.Event>> GetEventsAsync(int ModuleId);

        Task<Models.Event> AddEventAsync(Models.Event NewEvent);

        Task<Models.Event> UpdateEventAsync(Models.Event NewEvent);

        Task DeleteEventAsync(int EventId, int ModuleId);


        /* Events & Responses */
        Task<Models.Response> AddOrUpdateResponseAsync(int EventId, int ModuleId, bool ResponseType);

        Task<(Models.Event, Models.Response)> GetEventDetails(int EventId, int ModuleId);

        Task<List<Models.Response>> GetEventResponses(int EventId, int ModuleId);
    }
}
